// 
// File:          ccaffeine_ports_BuilderService.hxx
// Symbol:        ccaffeine.ports.BuilderService-v0.3
// Symbol Type:   class
// Babel Version: 1.4.0
// Description:   Client-side glue code for ccaffeine.ports.BuilderService
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_ccaffeine_ports_BuilderService_hxx
#define included_ccaffeine_ports_BuilderService_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace ccaffeine { 
  namespace ports { 

    class BuilderService;
  } // end namespace ports
} // end namespace ccaffeine

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::ccaffeine::ports::BuilderService >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class ComponentID;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class ConnectionID;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class TypeMap;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_ccaffeine_ports_BuilderService_IOR_h
#include "ccaffeine_ports_BuilderService_IOR.h"
#endif
#ifndef included_gov_cca_ports_BuilderService_hxx
#include "gov_cca_ports_BuilderService.hxx"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace ccaffeine { 
  namespace ports { 

    /**
     * Symbol "ccaffeine.ports.BuilderService" (version 0.3)
     * 
     *  This is a wrapper class. It cannot be successfully
     * constructed directly from component or client code.
     * Only the ccaffeine framework internals know how to initialize 
     * this object. If you want to use one, you should get
     * it as a port only in the form 'gov.cca.ports.BuilderService'.
     */
    class BuilderService: public virtual ::gov::cca::ports::BuilderService, 
      public virtual ::sidl::BaseClass {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
      static 
      void
      throwException1(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       *  @param ccafeopq_BuilderService_port a
       * ::ccafeopq::BuilderService  cast to void .
       * The pointer will be deleted when the babel wrapper
       * is destroyed.
       */
      void
      initialize (
        /* in */void* ccafeopq_BuilderService_port
      )
      ;



      /**
       *  add a new directory to the search path for components and babel classes 
       */
      void
      appendRepositoryPath (
        /* in */const ::std::string& dirPathElement
      )
      ;



      /**
       *  cause ccaffeine to import metadata for the named class to palette. 
       */
      void
      loadComponentClass (
        /* in */const ::std::string& className,
        /* in */bool loadGlobal,
        /* in */bool loadLazy
      )
      ;



      /**
       * Creates an instance of a CCA component of the type defined by the 
       * string className.  The string classname uniquely defines the
       * "type" of the component, e.g.
       * doe.cca.Library.GaussianElmination. 
       * It has an instance name given by the string instanceName.
       * The instanceName may be empty (zero length) in which case
       * the instanceName will be assigned to the component automatically.
       * @throws CCAException If the Component className is unknown, or if the
       * instanceName has already been used, a CCAException is thrown.
       * @return A ComponentID corresponding to the created component. Destroying
       * the returned ID does not destroy the component; 
       * see destroyInstance instead.
       */
      ::gov::cca::ComponentID
      createInstance (
        /* in */const ::std::string& instanceName,
        /* in */const ::std::string& className,
        /* in */const ::gov::cca::TypeMap& properties
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  
       * Get component list.
       * @return a ComponentID for each component currently created.
       */
      ::sidl::array< ::gov::cca::ComponentID>
      getComponentIDs() // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;


      /**
       *  
       * Get property map for component.
       * @return the public properties associated with the component referred to by
       * ComponentID. 
       * @throws a CCAException if the ComponentID is invalid.
       */
      ::gov::cca::TypeMap
      getComponentProperties (
        /* in */const ::gov::cca::ComponentID& cid
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       * Causes the framework implementation to associate the given properties 
       * with the component designated by cid. 
       * @throws CCAException if cid is invalid or if there is an attempted
       * change to a property locked by the framework implementation.
       */
      void
      setComponentProperties (
        /* in */const ::gov::cca::ComponentID& cid,
        /* in */const ::gov::cca::TypeMap& map
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Get component id from stringified reference.
       * @return a ComponentID from the string produced by 
       * ComponentID.getSerialization(). 
       * @throws CCAException if the string does not represent the appropriate 
       * serialization of a ComponentID for the underlying framework.
       */
      ::gov::cca::ComponentID
      getDeserialization (
        /* in */const ::std::string& s
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Get id from name by which it was created.
       * @return a ComponentID from the instance name of the component
       * produced by ComponentID.getInstanceName().
       * @throws CCAException if there is no component matching the 
       * given componentInstanceName.
       */
      ::gov::cca::ComponentID
      getComponentID (
        /* in */const ::std::string& componentInstanceName
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  
       * Eliminate the Component instance, from the scope of the framework.
       * @param toDie the component to be removed.
       * @param timeout the allowable wait; 0 means up to the framework.
       * @throws CCAException if toDie refers to an invalid component, or
       * if the operation takes longer than timeout seconds.
       */
      void
      destroyInstance (
        /* in */const ::gov::cca::ComponentID& toDie,
        /* in */float timeout
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  
       * Get the names of Port instances provided by the identified component.
       * @param cid the component.
       * @throws CCAException if cid refers to an invalid component.
       */
      ::sidl::array< ::std::string>
      getProvidedPortNames (
        /* in */const ::gov::cca::ComponentID& cid
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  
       * Get the names of Port instances used by the identified component.
       * @param cid the component.
       * @throws CCAException if cid refers to an invalid component. 
       */
      ::sidl::array< ::std::string>
      getUsedPortNames (
        /* in */const ::gov::cca::ComponentID& cid
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  
       * Fetch map of Port properties exposed by the framework.
       * @return the public properties pertaining to the Port instance 
       * portname on the component referred to by cid. 
       * @throws CCAException when any one of the following conditions occur:<ul>
       * <li>portname is not a registered Port on the component indicated by cid,
       * <li>cid refers to an invalid component. </ul>
       */
      ::gov::cca::TypeMap
      getPortProperties (
        /* in */const ::gov::cca::ComponentID& cid,
        /* in */const ::std::string& portName
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  
       * Associates the properties given in map with the Port indicated by 
       * portname. The component must have a Port known by portname.
       * @throws CCAException if either cid or portname are
       * invalid, or if this a changed property is locked by 
       * the underlying framework or component.
       */
      void
      setPortProperties (
        /* in */const ::gov::cca::ComponentID& cid,
        /* in */const ::std::string& portName,
        /* in */const ::gov::cca::TypeMap& map
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       * Creates a connection between ports on component user and 
       * component provider. Destroying the ConnectionID does not
       * cause a disconnection; for that, see disconnect().
       * @throws CCAException when any one of the following conditions occur:<ul>
       * <li>If either user or provider refer to an invalid component,
       * <li>If either usingPortName or providingPortName refer to a 
       * nonexistent Port on their respective component,
       * <li>If other-- In reality there are a lot of things that can go wrong 
       * with this operation, especially if the underlying connections 
       * involve networking.</ul>
       */
      ::gov::cca::ConnectionID
      connect (
        /* in */const ::gov::cca::ComponentID& user,
        /* in */const ::std::string& usingPortName,
        /* in */const ::gov::cca::ComponentID& provider,
        /* in */const ::std::string& providingPortName
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Returns a list of connections as an array of 
       * handles. This will return all connections involving components 
       * in the given componentList of ComponentIDs. This
       * means that ConnectionID's will be returned even if only one 
       * of the participants in the connection appears in componentList.
       * 
       * @throws CCAException if any component in componentList is invalid.
       */
      ::sidl::array< ::gov::cca::ConnectionID>
      getConnectionIDs (
        /* in array<gov.cca.ComponentID> */const ::sidl::array< 
          ::gov::cca::ComponentID>& componentList
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       * Fetch property map of a connection.
       * @returns the properties for the given connection.
       * @throws CCAException if connID is invalid.
       */
      ::gov::cca::TypeMap
      getConnectionProperties (
        /* in */const ::gov::cca::ConnectionID& connID
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Associates the properties with the connection.
       * @param map the source of the properties.
       * @param connID connection to receive property values.
       * @throws CCAException if connID is invalid, or if this changes 
       * a property locked by the underlying framework.
       */
      void
      setConnectionProperties (
        /* in */const ::gov::cca::ConnectionID& connID,
        /* in */const ::gov::cca::TypeMap& map
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Disconnect the connection indicated by connID before the indicated
       * timeout in secs. Upon successful completion, connID and the connection
       * it represents become invalid. 
       * @param timeout the time in seconds to wait for a connection to close; 0
       * means to use the framework implementation default.
       * @param connID the connection to be broken.
       * @throws CCAException when any one of the following conditions occur: <ul>
       * <li>id refers to an invalid ConnectionID,
       * <li>timeout is exceeded, after which, if id was valid before 
       * disconnect() was invoked, it remains valid
       * </ul>
       */
      void
      disconnect (
        /* in */const ::gov::cca::ConnectionID& connID,
        /* in */float timeout
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Remove all connections between components id1 and id2 within 
       * the period of timeout secs. If id2 is null, then all connections 
       * to id1 are removed (within the period of timeout secs).
       * @throws CCAException when any one of the following conditions occur:<ul>
       * <li>id1 or id2 refer to an invalid ComponentID (other than id2 == null),
       * <li>The timeout period is exceeded before the disconnections can be made. 
       * </ul>
       */
      void
      disconnectAll (
        /* in */const ::gov::cca::ComponentID& id1,
        /* in */const ::gov::cca::ComponentID& id2,
        /* in */float timeout
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct ccaffeine_ports_BuilderService__object ior_t;
      typedef struct ccaffeine_ports_BuilderService__external ext_t;
      typedef struct ccaffeine_ports_BuilderService__sepv sepv_t;

      // default constructor
      BuilderService() { }
      // static constructor
      static ::ccaffeine::ports::BuilderService _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::ccaffeine::ports::BuilderService _create( /*in*/ const 
        std::string& url );

      // RMI connect
      static inline ::ccaffeine::ports::BuilderService _connect( /*in*/ const 
        std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::ccaffeine::ports::BuilderService _connect( /*in*/ const 
        std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~BuilderService () { }

      // copy constructor
      BuilderService ( const BuilderService& original );

      // assignment operator
      BuilderService& operator= ( const BuilderService& rhs );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      BuilderService ( BuilderService::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      BuilderService ( BuilderService::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          gov_cca_Port_IORCache = &((*ptr).d_gov_cca_port);
          gov_cca_ports_BuilderService_IORCache = &((
            *ptr).d_gov_cca_ports_builderservice);
        } else {
          gov_cca_Port_IORCache = NULL;
          gov_cca_ports_BuilderService_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "ccaffeine.ports.BuilderService";}

      static struct ccaffeine_ports_BuilderService__object* _cast(const void* 
        src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable interface contract enforcement.
       */
      void
      _set_contracts (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to dump contract enforcement statistics.
       */
      void
      _dump_stats (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class BuilderService
  } // end namespace ports
} // end namespace ccaffeine

extern "C" {


#pragma weak ccaffeine_ports_BuilderService__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct ccaffeine_ports_BuilderService__object*
  ccaffeine_ports_BuilderService__connectI(const char * url, sidl_bool ar, 
    struct sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::ccaffeine::ports::BuilderService > {
    typedef array< ::ccaffeine::ports::BuilderService > cxx_array_t;
    typedef ::ccaffeine::ports::BuilderService cxx_item_t;
    typedef struct ccaffeine_ports_BuilderService__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct ccaffeine_ports_BuilderService__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::ccaffeine::ports::BuilderService > > 
      iterator;
    typedef const_array_iter< array_traits< ::ccaffeine::ports::BuilderService 
      > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::ccaffeine::ports::BuilderService >: public interface_array< 
    array_traits< ::ccaffeine::ports::BuilderService > > {
  public:
    typedef interface_array< array_traits< ::ccaffeine::ports::BuilderService > 
      > Base;
    typedef array_traits< ::ccaffeine::ports::BuilderService >::cxx_array_t     
      cxx_array_t;
    typedef array_traits< ::ccaffeine::ports::BuilderService >::cxx_item_t      
      cxx_item_t;
    typedef array_traits< ::ccaffeine::ports::BuilderService >::ior_array_t     
      ior_array_t;
    typedef array_traits< ::ccaffeine::ports::BuilderService 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::ccaffeine::ports::BuilderService >::ior_item_t      
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct ccaffeine_ports_BuilderService__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::ccaffeine::ports::BuilderService >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::ccaffeine::ports::BuilderService >&
    operator =( const array< ::ccaffeine::ports::BuilderService >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_gov_cca_ComponentID_hxx
#include "gov_cca_ComponentID.hxx"
#endif
#ifndef included_gov_cca_ConnectionID_hxx
#include "gov_cca_ConnectionID.hxx"
#endif
#ifndef included_gov_cca_TypeMap_hxx
#include "gov_cca_TypeMap.hxx"
#endif
#endif
