// 
// File:          ccaffeine_ports_ConnectionEvent.hxx
// Symbol:        ccaffeine.ports.ConnectionEvent-v0.3
// Symbol Type:   class
// Babel Version: 1.4.0
// Description:   Client-side glue code for ccaffeine.ports.ConnectionEvent
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_ccaffeine_ports_ConnectionEvent_hxx
#define included_ccaffeine_ports_ConnectionEvent_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace ccaffeine { 
  namespace ports { 

    class ConnectionEvent;
  } // end namespace ports
} // end namespace ccaffeine

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::ccaffeine::ports::ConnectionEvent >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class TypeMap;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_ccaffeine_ports_ConnectionEvent_IOR_h
#include "ccaffeine_ports_ConnectionEvent_IOR.h"
#endif
#ifndef included_gov_cca_ports_ConnectionEvent_hxx
#include "gov_cca_ports_ConnectionEvent.hxx"
#endif
#ifndef included_gov_cca_ports_EventType_hxx
#include "gov_cca_ports_EventType.hxx"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace ccaffeine { 
  namespace ports { 

    /**
     * Symbol "ccaffeine.ports.ConnectionEvent" (version 0.3)
     * 
     *  This is a wrapper class. It cannot be successfully
     * constructed directly from component or client code.
     * Only the ccaffeine framework
     * internals know how to initialize this object.
     */
    class ConnectionEvent: public virtual ::gov::cca::ports::ConnectionEvent, 
      public virtual ::sidl::BaseClass {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:
      /**
       * user defined non-static method
       */
      void
      initialize (
        /* in */::gov::cca::ports::EventType eventType,
        /* in */const ::gov::cca::TypeMap& portProperties
      )
      ;



      /**
       *  
       * <p>Returns the integer from those enumerated that describes the event.</p>
       * 
       * <p>
       * The semantics are noted before
       * each member of the enum/static constant. We can add in different
       * types of connect/disconnect as multiports and
       * explicit local/global/sync/async semantics are agreed to in the future.
       * At present we assume that:
       * <ul>
       * <li> All instances in a component cohort (often thought of as a single
       * "parallel component") receive all the events
       * and in the same order, but not necessarily globally synchronously.
       * 
       * <li> For disconnections, within a process the events are delivered first
       * to the using component then (if necessary) to the providing
       * component.
       * 
       * <li> For connections, within a process the events are delivered first
       * to the providing component then (if necessary) to the using
       * component.
       * </ul>
       * </p>
       * 
       * <p>
       * Clearly some of the assumptions above may not suit a component
       * instance in which multiple execution threads act on a
       * single instance of the <code>cca.Services</code> object (SMP). The Services
       * specification is ambiguous as to whether such a component is even
       * allowed.
       * </p>
       * <p>
       * When this is clarified, additional members of the enum may arise,
       * in which case the assumptions here apply only to
       * <code>ConnectPending</code>, <code>Connected</code>, <code>DisconnectPending</code>, 
       * <code>Disconnected</code> types.
       */
      ::gov::cca::ports::EventType
      getEventType() ;


      /**
       *  
       * Get Properties of the affected Port.
       * Among the standard properties are the name and type info.
       * The keys are cca.portName, cca.portType.
       */
      ::gov::cca::TypeMap
      getPortInfo() ;


      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct ccaffeine_ports_ConnectionEvent__object ior_t;
      typedef struct ccaffeine_ports_ConnectionEvent__external ext_t;
      typedef struct ccaffeine_ports_ConnectionEvent__sepv sepv_t;

      // default constructor
      ConnectionEvent() { }
      // static constructor
      static ::ccaffeine::ports::ConnectionEvent _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::ccaffeine::ports::ConnectionEvent _create( /*in*/ const 
        std::string& url );

      // RMI connect
      static inline ::ccaffeine::ports::ConnectionEvent _connect( /*in*/ const 
        std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::ccaffeine::ports::ConnectionEvent _connect( /*in*/ const 
        std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~ConnectionEvent () { }

      // copy constructor
      ConnectionEvent ( const ConnectionEvent& original );

      // assignment operator
      ConnectionEvent& operator= ( const ConnectionEvent& rhs );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      ConnectionEvent ( ConnectionEvent::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      ConnectionEvent ( ConnectionEvent::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          gov_cca_ports_ConnectionEvent_IORCache = &((
            *ptr).d_gov_cca_ports_connectionevent);
        } else {
          gov_cca_ports_ConnectionEvent_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "ccaffeine.ports.ConnectionEvent";}

      static struct ccaffeine_ports_ConnectionEvent__object* _cast(const void* 
        src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable interface contract enforcement.
       */
      void
      _set_contracts (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to dump contract enforcement statistics.
       */
      void
      _dump_stats (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class ConnectionEvent
  } // end namespace ports
} // end namespace ccaffeine

extern "C" {


#pragma weak ccaffeine_ports_ConnectionEvent__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct ccaffeine_ports_ConnectionEvent__object*
  ccaffeine_ports_ConnectionEvent__connectI(const char * url, sidl_bool ar, 
    struct sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::ccaffeine::ports::ConnectionEvent > {
    typedef array< ::ccaffeine::ports::ConnectionEvent > cxx_array_t;
    typedef ::ccaffeine::ports::ConnectionEvent cxx_item_t;
    typedef struct ccaffeine_ports_ConnectionEvent__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct ccaffeine_ports_ConnectionEvent__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::ccaffeine::ports::ConnectionEvent > > 
      iterator;
    typedef const_array_iter< array_traits< ::ccaffeine::ports::ConnectionEvent 
      > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::ccaffeine::ports::ConnectionEvent >: public interface_array< 
    array_traits< ::ccaffeine::ports::ConnectionEvent > > {
  public:
    typedef interface_array< array_traits< ::ccaffeine::ports::ConnectionEvent 
      > > Base;
    typedef array_traits< ::ccaffeine::ports::ConnectionEvent >::cxx_array_t    
      cxx_array_t;
    typedef array_traits< ::ccaffeine::ports::ConnectionEvent >::cxx_item_t     
      cxx_item_t;
    typedef array_traits< ::ccaffeine::ports::ConnectionEvent >::ior_array_t    
      ior_array_t;
    typedef array_traits< ::ccaffeine::ports::ConnectionEvent 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::ccaffeine::ports::ConnectionEvent >::ior_item_t     
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct ccaffeine_ports_ConnectionEvent__array* src = 0) : Base(src) 
      {}

    /**
     * copy constructor
     */
    array( const array< ::ccaffeine::ports::ConnectionEvent >&src) : Base(src) 
      {}

    /**
     * assignment
     */
    array< ::ccaffeine::ports::ConnectionEvent >&
    operator =( const array< ::ccaffeine::ports::ConnectionEvent >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_gov_cca_TypeMap_hxx
#include "gov_cca_TypeMap.hxx"
#endif
#endif
