// 
// File:          ccaffeine_ports_MPIBorrow.hxx
// Symbol:        ccaffeine.ports.MPIBorrow-v0.3
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for ccaffeine.ports.MPIBorrow
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_ccaffeine_ports_MPIBorrow_hxx
#define included_ccaffeine_ports_MPIBorrow_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace ccaffeine { 
  namespace ports { 

    class MPIBorrow;
  } // end namespace ports
} // end namespace ccaffeine

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::ccaffeine::ports::MPIBorrow >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_ccaffeine_ports_MPIBorrow_IOR_h
#include "ccaffeine_ports_MPIBorrow_IOR.h"
#endif
#ifndef included_gov_cca_Port_hxx
#include "gov_cca_Port.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace ccaffeine { 
  namespace ports { 

    /**
     * Symbol "ccaffeine.ports.MPIBorrow" (version 0.3)
     * 
     *  "ccafe.ports.MPIBorrow" :
     * UNADOPTED-standard service for getting a shared communicator. 
     * 
     * As MPI Forum explicitly DOES NOT define an interlanguage
     * form for object (comm, group, etc) handles, we use the
     * FORTRAN form which, being an integer of some size <= long
     * in sidl, we will express in SIDL as a long.
     * Implementations in C/C++/Python will have to use appropriate
     * conversion operators, MPI_Comm_c2f/MPI_Comm_f2c, when
     * passing/receiving object handles in long form.
     */
    class MPIBorrow: public virtual ::gov::cca::Port {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException1(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       *  Get a communicator of the port provider (in FORTRAN form).
       * This communicator will be the same instance as the comm of the
       * port provider, with all the message collision potential that implies.
       * Instances which have a comm covering only a subset of themselves
       * will return FORTRAN MPI_COMM_NULL on their "un-covered" processes.
       * 
       * @param tagCount: The number of tags the borrower wishes to use
       * all to itself.
       * @param tagList: Array to be filled with tags available. The
       * array given as input is at least tagCount long and
       * indexes from 0.
       * @param key: key to be returned when the tags and comm are done with.
       * @return The comm being borrowed, in FORTRAN form. C callers use comm_f2c
       * method defined by their mpi implementation, usually MPI_Comm_f2c,
       * to convert result to MPI_Comm.
       * @throw CCAException if the service cannot be implemented because MPI is
       * not present.
       */
      int64_t
      borrowComm (
        /* in */int32_t tagsRequested,
        /* inout array<int> */::sidl::array<int32_t>& tagList,
        /* inout */int32_t& key
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Return a previously borrowed communicator and tag list.
       * @param tagCount: The length of tagList.
       * @param tagList: The tags being returned, at least tagCount long.
       * @param key: The key obtained with borrowComm. It is
       * an error to attempt to return tags that you didn't receive.
       * @throw CCAException if an error is detected.
       */
      void
      returnComm (
        /* in */int64_t comm,
        /* in */int32_t tagsRequested,
        /* inout array<int> */::sidl::array<int32_t>& tagList,
        /* in */int32_t key
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct ccaffeine_ports_MPIBorrow__object ior_t;
      typedef struct ccaffeine_ports_MPIBorrow__external ext_t;
      typedef struct ccaffeine_ports_MPIBorrow__sepv sepv_t;

      // default constructor
      MPIBorrow()  : ccaffeine_ports_MPIBorrow_IORCache((ior_t*) NULL){ }

#ifdef WITH_RMI

      // RMI connect
      static inline ::ccaffeine::ports::MPIBorrow _connect( /*in*/ const 
        std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::ccaffeine::ports::MPIBorrow _connect( /*in*/ const std::string& 
        url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~MPIBorrow () { }

      // copy constructor
      MPIBorrow ( const MPIBorrow& original );

      // assignment operator
      MPIBorrow& operator= ( const MPIBorrow& rhs );

      // conversion from ior to C++ class
      MPIBorrow ( MPIBorrow::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      MPIBorrow ( MPIBorrow::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        if(!ccaffeine_ports_MPIBorrow_IORCache) { 
          ccaffeine_ports_MPIBorrow_IORCache = 
            ::ccaffeine::ports::MPIBorrow::_cast((void*)d_self);
          if (ccaffeine_ports_MPIBorrow_IORCache) {
            struct sidl_BaseInterface__object *throwaway_exception;
            (ccaffeine_ports_MPIBorrow_IORCache->d_epv->f_deleteRef)(
              ccaffeine_ports_MPIBorrow_IORCache->d_object, 
              &throwaway_exception);  
          }  
        }
        return ccaffeine_ports_MPIBorrow_IORCache;
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);
        ccaffeine_ports_MPIBorrow_IORCache = (ior_t*) ptr;

        gov_cca_Port_IORCache = NULL;
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "ccaffeine.ports.MPIBorrow";}

      static struct ccaffeine_ports_MPIBorrow__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable interface contract enforcement.
       */
      void
      _set_contracts (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to dump contract enforcement statistics.
       */
      void
      _dump_stats (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


      //////////////////////////////////////////////////
      // 
      // Locally Cached IOR pointer
      // 

    protected:
      mutable ior_t* ccaffeine_ports_MPIBorrow_IORCache;
    }; // end class MPIBorrow
  } // end namespace ports
} // end namespace ccaffeine

extern "C" {


#pragma weak ccaffeine_ports_MPIBorrow__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct ccaffeine_ports_MPIBorrow__object*
  ccaffeine_ports_MPIBorrow__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::ccaffeine::ports::MPIBorrow > {
    typedef array< ::ccaffeine::ports::MPIBorrow > cxx_array_t;
    typedef ::ccaffeine::ports::MPIBorrow cxx_item_t;
    typedef struct ccaffeine_ports_MPIBorrow__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct ccaffeine_ports_MPIBorrow__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::ccaffeine::ports::MPIBorrow > > 
      iterator;
    typedef const_array_iter< array_traits< ::ccaffeine::ports::MPIBorrow > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::ccaffeine::ports::MPIBorrow >: public interface_array< 
    array_traits< ::ccaffeine::ports::MPIBorrow > > {
  public:
    typedef interface_array< array_traits< ::ccaffeine::ports::MPIBorrow > > 
      Base;
    typedef array_traits< ::ccaffeine::ports::MPIBorrow >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::ccaffeine::ports::MPIBorrow >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::ccaffeine::ports::MPIBorrow >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::ccaffeine::ports::MPIBorrow >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::ccaffeine::ports::MPIBorrow >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct ccaffeine_ports_MPIBorrow__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::ccaffeine::ports::MPIBorrow >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::ccaffeine::ports::MPIBorrow >&
    operator =( const array< ::ccaffeine::ports::MPIBorrow >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
