// 
// File:          ccaffeine_ports_MPIService.hxx
// Symbol:        ccaffeine.ports.MPIService-v0.3
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for ccaffeine.ports.MPIService
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_ccaffeine_ports_MPIService_hxx
#define included_ccaffeine_ports_MPIService_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace ccaffeine { 
  namespace ports { 

    class MPIService;
  } // end namespace ports
} // end namespace ccaffeine

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::ccaffeine::ports::MPIService >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_ccaffeine_ports_MPIService_IOR_h
#include "ccaffeine_ports_MPIService_IOR.h"
#endif
#ifndef included_gov_cca_Port_hxx
#include "gov_cca_Port.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace ccaffeine { 
  namespace ports { 

    /**
     * Symbol "ccaffeine.ports.MPIService" (version 0.3)
     * 
     *  
     * "ccafe.ports.MPIService": 
     * UNADOPTED-standard service for getting a private mpi comm.
     * 
     * As MPI Forum explicitly DOES NOT define an interlanguage
     * form for object (comm, group, etc) handles, we use the
     * FORTRAN form which, being an integer of some size <= long
     * in SIDL, we will express in SIDL as a long.
     * Implementations in C/C++/Python will have to use appropriate
     * conversion operators, MPI_Comm_c2f/MPI_Comm_f2c etc, when
     * passing/receiving object handles in long form.
     */
    class MPIService: public virtual ::gov::cca::Port {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException1(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       *  Get an mpi communicator with the same scope as the component instance.
       * Won't be mpi_comm_null. The communicator returned will be
       * private to the recipient, which implies an mpicommdup.
       * @return The comm produced, in FORTRAN form. C callers use comm_f2c
       * method defined by their mpi implementation, usually MPI_Comm_f2c,
       * to convert result to MPI_Comm.
       * @throw CCAException if the service cannot be implemented because MPI is
       * not present.
       */
      int64_t
      getComm() // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;


      /**
       *  Let go the communicator. previously fetched with getComm.
       * @throw CCAException if an error is detected.
       */
      void
      releaseComm (
        /* in */int64_t comm
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct ccaffeine_ports_MPIService__object ior_t;
      typedef struct ccaffeine_ports_MPIService__external ext_t;
      typedef struct ccaffeine_ports_MPIService__sepv sepv_t;

      // default constructor
      MPIService()  : ccaffeine_ports_MPIService_IORCache((ior_t*) NULL){ }

#ifdef WITH_RMI

      // RMI connect
      static inline ::ccaffeine::ports::MPIService _connect( /*in*/ const 
        std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::ccaffeine::ports::MPIService _connect( /*in*/ const std::string& 
        url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~MPIService () { }

      // copy constructor
      MPIService ( const MPIService& original );

      // assignment operator
      MPIService& operator= ( const MPIService& rhs );

      // conversion from ior to C++ class
      MPIService ( MPIService::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      MPIService ( MPIService::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        if(!ccaffeine_ports_MPIService_IORCache) { 
          ccaffeine_ports_MPIService_IORCache = 
            ::ccaffeine::ports::MPIService::_cast((void*)d_self);
          if (ccaffeine_ports_MPIService_IORCache) {
            struct sidl_BaseInterface__object *throwaway_exception;
            (ccaffeine_ports_MPIService_IORCache->d_epv->f_deleteRef)(
              ccaffeine_ports_MPIService_IORCache->d_object, 
              &throwaway_exception);  
          }  
        }
        return ccaffeine_ports_MPIService_IORCache;
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);
        ccaffeine_ports_MPIService_IORCache = (ior_t*) ptr;

        gov_cca_Port_IORCache = NULL;
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "ccaffeine.ports.MPIService";}

      static struct ccaffeine_ports_MPIService__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable interface contract enforcement.
       */
      void
      _set_contracts (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to dump contract enforcement statistics.
       */
      void
      _dump_stats (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


      //////////////////////////////////////////////////
      // 
      // Locally Cached IOR pointer
      // 

    protected:
      mutable ior_t* ccaffeine_ports_MPIService_IORCache;
    }; // end class MPIService
  } // end namespace ports
} // end namespace ccaffeine

extern "C" {


#pragma weak ccaffeine_ports_MPIService__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct ccaffeine_ports_MPIService__object*
  ccaffeine_ports_MPIService__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::ccaffeine::ports::MPIService > {
    typedef array< ::ccaffeine::ports::MPIService > cxx_array_t;
    typedef ::ccaffeine::ports::MPIService cxx_item_t;
    typedef struct ccaffeine_ports_MPIService__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct ccaffeine_ports_MPIService__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::ccaffeine::ports::MPIService > > 
      iterator;
    typedef const_array_iter< array_traits< ::ccaffeine::ports::MPIService > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::ccaffeine::ports::MPIService >: public interface_array< 
    array_traits< ::ccaffeine::ports::MPIService > > {
  public:
    typedef interface_array< array_traits< ::ccaffeine::ports::MPIService > > 
      Base;
    typedef array_traits< ::ccaffeine::ports::MPIService >::cxx_array_t         
      cxx_array_t;
    typedef array_traits< ::ccaffeine::ports::MPIService >::cxx_item_t          
      cxx_item_t;
    typedef array_traits< ::ccaffeine::ports::MPIService >::ior_array_t         
      ior_array_t;
    typedef array_traits< ::ccaffeine::ports::MPIService 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::ccaffeine::ports::MPIService >::ior_item_t          
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct ccaffeine_ports_MPIService__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::ccaffeine::ports::MPIService >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::ccaffeine::ports::MPIService >&
    operator =( const array< ::ccaffeine::ports::MPIService >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
