// 
// File:          ccaffeine_ports_ParameterPortFactoryWrap.hxx
// Symbol:        ccaffeine.ports.ParameterPortFactoryWrap-v0.3
// Symbol Type:   class
// Babel Version: 1.4.0
// Description:   Client-side glue code for ccaffeine.ports.ParameterPortFactoryWrap
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_ccaffeine_ports_ParameterPortFactoryWrap_hxx
#define included_ccaffeine_ports_ParameterPortFactoryWrap_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace ccaffeine { 
  namespace ports { 

    class ParameterPortFactoryWrap;
  } // end namespace ports
} // end namespace ccaffeine

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::ccaffeine::ports::ParameterPortFactoryWrap >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class Services;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class TypeMap;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 
    namespace ports { 

      class ParameterGetListener;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 
    namespace ports { 

      class ParameterSetListener;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_ccaffeine_ports_ParameterPortFactoryWrap_IOR_h
#include "ccaffeine_ports_ParameterPortFactoryWrap_IOR.h"
#endif
#ifndef included_gov_cca_ports_ParameterPortFactory_hxx
#include "gov_cca_ports_ParameterPortFactory.hxx"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace ccaffeine { 
  namespace ports { 

    /**
     * Symbol "ccaffeine.ports.ParameterPortFactoryWrap" (version 0.3)
     * 
     *  ccaffeine implementation of cca standard. 
     */
    class ParameterPortFactoryWrap: public virtual 
      ::gov::cca::ports::ParameterPortFactory, public virtual ::sidl::BaseClass 
      {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
      static 
      void
      throwException1(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       *  passed in is a void  cast pointer of
       * ccafeopq::ports::ParameterPortFactory .
       */
      void
      initialize (
        /* in */void* co_p_ParameterPortFactory_star
      )
      ;



      /**
       *  fetch up a pointer for static casting. if the name
       * supplied is not exactly right, returns null.
       */
      void*
      getWrapped (
        /* in */const ::std::string& className
      )
      ;



      /**
       *  Initialize the portData for use in a ParameterPort
       * with name portName.
       * More than one such port can be defined.
       * The given string portName will be cached in the TypeMap
       * as the result of this function and must not be changed
       * by the component henceforth.
       * 
       * @param portData the user-supplied TypeMap associated with the port;
       * It is somehow shared between the ParameterPortFactory
       * and the component. The ParameterPortFactory will
       * not read or change preexisting values in portData except those
       * requested via the addRequest functions and those
       * keys starting with the reserved prefix "gcpPPF.".
       * @param portName The name of the ParameterPort to appear in
       * the component. It must not conflict with other port
       * names in the same component. The port name "CONFIG"
       * is recommended if only one ParameterPort is being defined.
       */
      void
      initParameterData (
        /* inout */::gov::cca::TypeMap& portData,
        /* in */const ::std::string& portName
      )
      ;



      /**
       *  Define the window title for the parameter UI dialog.
       */
      void
      setBatchTitle (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& title
      )
      ;



      /**
       *  Define the next tab/group title to use. All
       * addRequest subsequent calls will add to this group.
       * Multiple dialog tabs/groups can be defined in this way.
       * @param newGroupName a one-word name for the group.
       * @param portData the hash-table which we're subsetting
       * with a tab notation.
       */
      void
      setGroupName (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& newGroupName
      )
      ;



      /**
       *  Define the next tab/group title to use. All
       * addRequest subsequent calls will add to this group.
       * Multiple dialog tabs/groups can be defined in this way.
       * @param portData the hash-table which we're subsetting
       * with a tab notation.
       * @param newGroupName a one-word name for the group.
       * @param groupTitle an optional title for the group.
       */
      void
      setGroupName (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& newGroupName,
        /* in */const ::std::string& groupTitle
      )
      ;



      /**
       *  Define a boolean parameter and its default state.
       * The configured value is always available by
       * portData.getBool(name, ...);
       * @throws gov.cca.CCAException if key is known and mistyped.
       */
      void
      addRequestBoolean (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in */const ::std::string& help,
        /* in */const ::std::string& prompt,
        /* in */bool bdefault
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Define a int parameter and its default state.
       * The configured value is always available by
       * portData.getInt(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is known and mistyped.
       */
      void
      addRequestInt (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in */const ::std::string& help,
        /* in */const ::std::string& prompt,
        /* in */int32_t idefault,
        /* in */int32_t low,
        /* in */int32_t high
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Define a long parameter and its default state.
       * The configured value is always available by
       * portData.getLong(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestLong (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in */const ::std::string& help,
        /* in */const ::std::string& prompt,
        /* in */int64_t ldefault,
        /* in */int64_t low,
        /* in */int64_t high
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Define a float parameter and its default state.
       * The configured value is always available by
       * portData.getFloat(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestFloat (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in */const ::std::string& help,
        /* in */const ::std::string& prompt,
        /* in */float fdefault,
        /* in */float low,
        /* in */float high
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Define a double parameter and its default state.
       * The configured value is always available by
       * portData.getDouble(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestDouble (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in */const ::std::string& help,
        /* in */const ::std::string& prompt,
        /* in */double ddefault,
        /* in */double low,
        /* in */double high
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Define a string parameter and its default state.
       * The configured value is always available by
       * portData.getString(name, ...).
       * If no addRequestStringChoice calls are made, the
       * user input may be any string. If addRequestStringChoice
       * is used, the value will be one among the choices.
       * If addRequestStringChoice is used, deflt must
       * be among the choices defined.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestString (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in */const ::std::string& help,
        /* in */const ::std::string& prompt,
        /* in */const ::std::string& sdefault
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Define a new choice for a string parameter.
       * If no calls to this function are made for a given
       * name, then any form of string will be acceptable input.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestStringChoice (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& key,
        /* in */const ::std::string& choice
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  As addRequestStringChoice, but in bulk. 
       */
      void
      addStringChoices (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in array<string> */const ::sidl::array< ::std::string>& choices
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Replace the bounds on the named parameter by a list. 
       */
      void
      addIntChoices (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in array<int> */const ::sidl::array<int32_t>& choices
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Replace the bounds on the named parameter by a list. 
       */
      void
      addLongChoices (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in array<long> */const ::sidl::array<int64_t>& choices
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Replace the bounds on the named parameter by a list. 
       */
      void
      addFloatChoices (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in array<float> */const ::sidl::array<float>& choices
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Replace the bounds on the named parameter by a list. 
       */
      void
      addDoubleChoices (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in array<double> */const ::sidl::array<double>& choices
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Replace the bounds on the named parameter by a list. 
       */
      void
      addFcomplexChoices (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in array<fcomplex> */const ::sidl::array< ::sidl::fcomplex>& choices
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Replace the bounds on the named parameter by a list. 
       */
      void
      addDcomplexChoices (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::std::string& name,
        /* in array<dcomplex> */const ::sidl::array< ::sidl::dcomplex>& choices
      )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Clear all previously added requests, titles, groups. After
       * this call, it is as if the ParameterPort has
       * seen initParameterData but otherwise never configured.
       * The values of
       * previously defined parameters (but not bounds, etc)
       * remain in the TypeMap.
       * Typically, this is used only by someone implementing
       * the updateParameterPort function from
       * interface ParameterGetListener.
       */
      void
      clearRequests (
        /* in */const ::gov::cca::TypeMap& portData
      )
      ;



      /**
       *  
       * Register listener (the component) that wishes to have
       * a chance to change the contents of its ParameterPort
       * just before the parameters TypeMap, portData, is read.
       * @param powner a pointer to the listener that will be
       * forgotten when it is no longer needed. 
       * @param portData the hash-table being accessed.
       */
      void
      registerUpdater (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::gov::cca::ports::ParameterGetListener& powner
      )
      ;



      /**
       *  Register listener (the component) if it wishes to be
       * informed when an parameter is changed via writeConfigurationMap.
       * Listeners are called after values are set.
       */
      void
      registerUpdatedListener (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::gov::cca::ports::ParameterSetListener& powner
      )
      ;



      /**
       *  Signal that the ParameterPort is fully defined and should
       * now pop out on the component.
       * The component is free to hold the portData map internally
       * without adding it until some desired time.
       * The Services passed here
       * must be the component's own Services handle.
       * The ParameterPortFactory takes care of addProvidesPort.
       */
      void
      addParameterPort (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::gov::cca::Services& services
      )
      ;



      /**
       *  Cause a previously defined parameter port to go away.
       * This function should be called at component shutdown
       * (setService(0)) time for any parameter ports that have
       * been added but not yet removed.
       * The ParameterPortFactory takes care of removeProvidesPort.
       * This does not change the parameter values in the
       * TypeMap.
       */
      void
      removeParameterPort (
        /* in */const ::gov::cca::TypeMap& portData,
        /* in */const ::gov::cca::Services& services
      )
      ;



      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct ccaffeine_ports_ParameterPortFactoryWrap__object ior_t;
      typedef struct ccaffeine_ports_ParameterPortFactoryWrap__external ext_t;
      typedef struct ccaffeine_ports_ParameterPortFactoryWrap__sepv sepv_t;

      // default constructor
      ParameterPortFactoryWrap() { }
      // static constructor
      static ::ccaffeine::ports::ParameterPortFactoryWrap _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::ccaffeine::ports::ParameterPortFactoryWrap _create( /*in*/ const 
        std::string& url );

      // RMI connect
      static inline ::ccaffeine::ports::ParameterPortFactoryWrap _connect( 
        /*in*/ const std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::ccaffeine::ports::ParameterPortFactoryWrap _connect( /*in*/ 
        const std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~ParameterPortFactoryWrap () { }

      // copy constructor
      ParameterPortFactoryWrap ( const ParameterPortFactoryWrap& original );

      // assignment operator
      ParameterPortFactoryWrap& operator= ( const ParameterPortFactoryWrap& rhs 
        );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      ParameterPortFactoryWrap ( ParameterPortFactoryWrap::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      ParameterPortFactoryWrap ( ParameterPortFactoryWrap::ior_t* ior, bool 
        isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          gov_cca_Port_IORCache = &((*ptr).d_gov_cca_port);
          gov_cca_ports_ParameterPortFactory_IORCache = &((
            *ptr).d_gov_cca_ports_parameterportfactory);
        } else {
          gov_cca_Port_IORCache = NULL;
          gov_cca_ports_ParameterPortFactory_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "ccaffeine.ports.ParameterPortFactoryWrap";}

      static struct ccaffeine_ports_ParameterPortFactoryWrap__object* _cast(
        const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable interface contract enforcement.
       */
      void
      _set_contracts (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to dump contract enforcement statistics.
       */
      void
      _dump_stats (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class ParameterPortFactoryWrap
  } // end namespace ports
} // end namespace ccaffeine

extern "C" {


#pragma weak ccaffeine_ports_ParameterPortFactoryWrap__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct ccaffeine_ports_ParameterPortFactoryWrap__object*
  ccaffeine_ports_ParameterPortFactoryWrap__connectI(const char * url, 
    sidl_bool ar, struct sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::ccaffeine::ports::ParameterPortFactoryWrap > {
    typedef array< ::ccaffeine::ports::ParameterPortFactoryWrap > cxx_array_t;
    typedef ::ccaffeine::ports::ParameterPortFactoryWrap cxx_item_t;
    typedef struct ccaffeine_ports_ParameterPortFactoryWrap__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct ccaffeine_ports_ParameterPortFactoryWrap__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< 
      ::ccaffeine::ports::ParameterPortFactoryWrap > > iterator;
    typedef const_array_iter< array_traits< 
      ::ccaffeine::ports::ParameterPortFactoryWrap > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::ccaffeine::ports::ParameterPortFactoryWrap >: public 
    interface_array< array_traits< ::ccaffeine::ports::ParameterPortFactoryWrap 
    > > {
  public:
    typedef interface_array< array_traits< 
      ::ccaffeine::ports::ParameterPortFactoryWrap > > Base;
    typedef array_traits< ::ccaffeine::ports::ParameterPortFactoryWrap 
      >::cxx_array_t          cxx_array_t;
    typedef array_traits< ::ccaffeine::ports::ParameterPortFactoryWrap 
      >::cxx_item_t           cxx_item_t;
    typedef array_traits< ::ccaffeine::ports::ParameterPortFactoryWrap 
      >::ior_array_t          ior_array_t;
    typedef array_traits< ::ccaffeine::ports::ParameterPortFactoryWrap 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::ccaffeine::ports::ParameterPortFactoryWrap 
      >::ior_item_t           ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct ccaffeine_ports_ParameterPortFactoryWrap__array* src = 0) : 
      Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::ccaffeine::ports::ParameterPortFactoryWrap >&src) : 
      Base(src) {}

    /**
     * assignment
     */
    array< ::ccaffeine::ports::ParameterPortFactoryWrap >&
    operator =( const array< ::ccaffeine::ports::ParameterPortFactoryWrap >&rhs 
      ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_gov_cca_Services_hxx
#include "gov_cca_Services.hxx"
#endif
#ifndef included_gov_cca_TypeMap_hxx
#include "gov_cca_TypeMap.hxx"
#endif
#ifndef included_gov_cca_ports_ParameterGetListener_hxx
#include "gov_cca_ports_ParameterGetListener.hxx"
#endif
#ifndef included_gov_cca_ports_ParameterSetListener_hxx
#include "gov_cca_ports_ParameterSetListener.hxx"
#endif
#endif
