// 
// File:          ccaffeine_ports_PortTranslator.hxx
// Symbol:        ccaffeine.ports.PortTranslator-v0.3
// Symbol Type:   class
// Babel Version: 1.4.0
// Description:   Client-side glue code for ccaffeine.ports.PortTranslator
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_ccaffeine_ports_PortTranslator_hxx
#define included_ccaffeine_ports_PortTranslator_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace ccaffeine { 
  namespace ports { 

    class PortTranslator;
  } // end namespace ports
} // end namespace ccaffeine

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::ccaffeine::ports::PortTranslator >;
}
// 
// Forward declarations for method dependencies.
// 
namespace ccaffeine { 
  namespace ports { 

    class PortTranslator;
  } // end namespace ports
} // end namespace ccaffeine

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_ccaffeine_ports_PortTranslator_IOR_h
#include "ccaffeine_ports_PortTranslator_IOR.h"
#endif
#ifndef included_gov_cca_Port_hxx
#include "gov_cca_Port.hxx"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace ccaffeine { 
  namespace ports { 

    /**
     * Symbol "ccaffeine.ports.PortTranslator" (version 0.3)
     * 
     *  Foreign ports (i.e. Ports of a different (non)cca binding) are
     * wrapped by Ccaffeine in this class.  If a foreign port is
     * connected to a Babel component, an instance of
     * ccaffeine::PortTranslator is wrapped around it.  Moreover, if a
     * PortTranslator is exported through the addProvidesPort method on
     * Services, the contained port will be automatically delt with as
     * if the component belonged to the exported port's religion.
     * Several methods are provided on PortTranslator that will allow
     * access to the other Religions.  The methods return the foreign
     * port as a void and this is castable to exactly the indicated
     * Port type, and nothing else.  Further cast is required to get the
     * base Port type to a particular Port in the foreign
     * Religion. Example:
     * 
     * PortTranslator pt = getPort("my_classic_parameter_port");
     * classic::gov::cca::Port port = 
     * static_cast < classic::gov::cca::Port > (pt.getClassicPort());
     * if(port == NULL) {
     * perror("Hey this is not a Classic Port");        
     * }
     * ParameterPort pp = 
     * dynamic_cast< ParameterPort > (port);
     * if(pp == NULL) {
     * perror("Hey this is not a ParameterPort");
     * }
     * // use the pp now as you would in Classic Religion ...
     * 
     * Note that the following shortcut will yield unexpected results
     * and does not conform to the C++ standard:
     * 
     * // This is a REALLY BAD IDEA, DO NOT DO THIS:
     * PortTranslator pt = getPort("my_classic_parameter_port");
     * ParameterPort pp = (ParameterPort) (pt.getClassicPort());
     * 
     * SEE ALSO:
     * The principal use of this port has been to get at classic
     * parameter ports. Those users should instead consider using the
     * babel-native ParameterPort or the BasicParameterPort
     * defined in the specification. This will make their component
     * code much cleaner and less ccaffeine-cruft dependent.
     */
    class PortTranslator: public virtual ::gov::cca::Port, public virtual 
      ::sidl::BaseClass {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       * 	 Must be initialized with a ::ccafeopq::Port 
       */
      void
      initialize (
        /* in */void* opaquePort
      )
      ;



      /**
       *  Return a classic port.  The void  returned in C++ are
       * directly castable to a C++ classic::gov::cca::Port and only
       * that type.  Casting to the specific type must occur after. 
       */
      void*
      getClassicPort() ;


      /**
       *  unimplemented, returns NULL. 
       */
      void*
      getChasmPort() ;


      /**
       *  Return a raw OpaquePort.  The void  in C++ is directly
       * castable to a ccafeopq::Port.  
       */
      void*
      getRawPort() ;


      /**
       *  Create a new PortTranslator wrapper with a
       * classic::gov::cca::Port. If the type does not match this
       * specifically, unexpected results may occur, or more likely,
       * all get methods will return NULL.
       */
      static ::ccaffeine::ports::PortTranslator
      createFromClassic (
        /* in */void* classic_Port_ptr
      )
      ;



      /**
       *  Create a new PortTranslator wrapper with a ::ccafeopq::Port.
       * If the type does not match this specifically, unexpected
       * results may occur, or more likely, all get methods will return
       * NULL. 
       */
      static ::ccaffeine::ports::PortTranslator
      createFromRaw (
        /* in */void* ccafeopq_Port_ptr
      )
      ;



      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct ccaffeine_ports_PortTranslator__object ior_t;
      typedef struct ccaffeine_ports_PortTranslator__external ext_t;
      typedef struct ccaffeine_ports_PortTranslator__sepv sepv_t;

      // default constructor
      PortTranslator() { }
      // static constructor
      static ::ccaffeine::ports::PortTranslator _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::ccaffeine::ports::PortTranslator _create( /*in*/ const 
        std::string& url );

      // RMI connect
      static inline ::ccaffeine::ports::PortTranslator _connect( /*in*/ const 
        std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::ccaffeine::ports::PortTranslator _connect( /*in*/ const 
        std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~PortTranslator () { }

      // copy constructor
      PortTranslator ( const PortTranslator& original );

      // assignment operator
      PortTranslator& operator= ( const PortTranslator& rhs );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      PortTranslator ( PortTranslator::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      PortTranslator ( PortTranslator::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          gov_cca_Port_IORCache = &((*ptr).d_gov_cca_port);
        } else {
          gov_cca_Port_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "ccaffeine.ports.PortTranslator";}

      static struct ccaffeine_ports_PortTranslator__object* _cast(const void* 
        src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);
      // exec static member function by name
      static void _sexec(const std::string& methodName,
                         ::sidl::rmi::Call& inArgs,
                         ::sidl::rmi::Return& outArgs);


      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Static Method to enable/disable method hooks invocation.
       */
      static void
      _set_hooks_static (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable interface contract enforcement.
       */
      void
      _set_contracts (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Static Method to enable/disable interface contract enforcement.
       */
      static void
      _set_contracts_static (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to dump contract enforcement statistics.
       */
      void
      _dump_stats (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Static Method to dump contract enforcement statistics.
       */
      static void
      _dump_stats_static (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

      static const sepv_t * _get_sepv() {
        return (*(_get_ext()->getStaticEPV))();
      }

    }; // end class PortTranslator
  } // end namespace ports
} // end namespace ccaffeine

extern "C" {


#pragma weak ccaffeine_ports_PortTranslator__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct ccaffeine_ports_PortTranslator__object*
  ccaffeine_ports_PortTranslator__connectI(const char * url, sidl_bool ar, 
    struct sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::ccaffeine::ports::PortTranslator > {
    typedef array< ::ccaffeine::ports::PortTranslator > cxx_array_t;
    typedef ::ccaffeine::ports::PortTranslator cxx_item_t;
    typedef struct ccaffeine_ports_PortTranslator__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct ccaffeine_ports_PortTranslator__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::ccaffeine::ports::PortTranslator > > 
      iterator;
    typedef const_array_iter< array_traits< ::ccaffeine::ports::PortTranslator 
      > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::ccaffeine::ports::PortTranslator >: public interface_array< 
    array_traits< ::ccaffeine::ports::PortTranslator > > {
  public:
    typedef interface_array< array_traits< ::ccaffeine::ports::PortTranslator > 
      > Base;
    typedef array_traits< ::ccaffeine::ports::PortTranslator >::cxx_array_t     
      cxx_array_t;
    typedef array_traits< ::ccaffeine::ports::PortTranslator >::cxx_item_t      
      cxx_item_t;
    typedef array_traits< ::ccaffeine::ports::PortTranslator >::ior_array_t     
      ior_array_t;
    typedef array_traits< ::ccaffeine::ports::PortTranslator 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::ccaffeine::ports::PortTranslator >::ior_item_t      
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct ccaffeine_ports_PortTranslator__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::ccaffeine::ports::PortTranslator >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::ccaffeine::ports::PortTranslator >&
    operator =( const array< ::ccaffeine::ports::PortTranslator >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
