// 
// File:          ccafe6_MPIComponent.hxx
// Symbol:        ccafe6.MPIComponent-v0.0
// Symbol Type:   class
// Babel Version: 1.4.0
// Description:   Client-side glue code for ccafe6.MPIComponent
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_ccafe6_MPIComponent_hxx
#define included_ccafe6_MPIComponent_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace ccafe6 { 

  class MPIComponent;
} // end namespace ccafe6

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::ccafe6::MPIComponent >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class AbstractFramework;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class Services;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_ccafe6_MPIComponent_IOR_h
#include "ccafe6_MPIComponent_IOR.h"
#endif
#ifndef included_ccaffeine_ports_MPIBorrow_hxx
#include "ccaffeine_ports_MPIBorrow.hxx"
#endif
#ifndef included_ccaffeine_ports_MPIService_hxx
#include "ccaffeine_ports_MPIService.hxx"
#endif
#ifndef included_gov_cca_Component_hxx
#include "gov_cca_Component.hxx"
#endif
#ifndef included_gov_cca_ComponentRelease_hxx
#include "gov_cca_ComponentRelease.hxx"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace ccafe6 { 

  /**
   * Symbol "ccafe6.MPIComponent" (version 0.0)
   * 
   *  Externally added to the abstractframework, or loaded into
   * an environment which already supports mpi (mpi_init has been called).
   */
  class MPIComponent: public virtual ::ccaffeine::ports::MPIBorrow, public 
    virtual ::ccaffeine::ports::MPIService, public virtual 
    ::gov::cca::Component, public virtual ::gov::cca::ComponentRelease, public 
    virtual ::sidl::BaseClass {

    //////////////////////////////////////////////////
    // 
    // Special methods for throwing exceptions
    // 

  private:
    static 
    void
    throwException1(
      const char* methodName,
      struct sidl_BaseInterface__object *_exception
    )
      // throws:
    ;
    static 
    void
    throwException0(
      const char* methodName,
      struct sidl_BaseInterface__object *_exception
    )
      // throws:
      //    ::gov::cca::CCAException
      //    ::sidl::RuntimeException
    ;

    //////////////////////////////////////////////////
    // 
    // User Defined Methods
    // 

  public:

    /**
     *  Create and add to the framework MPIService and MPIBorrow
     * support services. This will appear in the frame as an
     * MPISetup component. MPI_Init must have been called before
     * this is called.
     * This entry point should work for any cca framework.
     * 
     * @param borrowComm  the shared communicator 
     * for those using MPIBorrow.
     * @param dupComm  the communicator to duplicate 
     * for those using MPIService.
     * @param af The frame into which the services will be added.
     */
    void
    initialize (
      /* in */int64_t borrowComm,
      /* in */int64_t dupComm,
      /* inout */::gov::cca::AbstractFramework& af
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    /**
     *  Create and add to the framework MPIService and MPIBorrow
     * support services. This will appear in the frame as an
     * MPISetup component. MPI_Init must have been called before
     * this is called.
     * This initializer assumes the MPIComponent is going into a
     * Ccaffeine framework, and fishes up the communicators accordingly.
     * @param af The frame into which the services will be added.
     */
    void
    initializeCcafe (
      /* inout */::gov::cca::AbstractFramework& af
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    /**
     * Shutdown the previous mpi-related services.
     * @param reclaim if reclaim true, try to release communicator
     * resources allocated in MPIService support.
     * Otherwise, lose them.
     */
    void
    finalize (
      /* in */bool reclaim
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    /**
     *  Starts up a component presence in the calling framework.
     * @param services the component instance's handle on the framework world.
     * Contracts concerning services and setServices:
     * 
     * The component interaction with the CCA framework
     * and Ports begins on the call to setServices by the framework.
     * 
     * This function is called exactly once for each instance created
     * by the framework.
     * 
     * The argument services will never be nil/null.
     * 
     * Those uses ports which are automatically connected by the framework
     * (so-called service-ports) may be obtained via getPort during
     * setServices.
     */
    void
    setServices (
      /* in */const ::gov::cca::Services& services
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    /**
     * Shuts down a component presence in the calling framework.
     * @param services the component instance's handle on the framework world.
     * Contracts concerning services and setServices:
     * 
     * This function is called exactly once for each callback registered
     * through Services.
     * 
     * The argument services will never be nil/null.
     * The argument services will always be the same as that received in
     * setServices.
     * 
     * During this call the component should release any interfaces
     * acquired by getPort().
     * 
     * During this call the component should reset to nil any stored
     * reference to services.
     * 
     * After this call, the component instance will be removed from the
     * framework. If the component instance was created by the
     * framework, it will be destroyed, not recycled, The behavior of
     * any port references obtained from this component instance and
     * stored elsewhere becomes undefined.
     * 
     * Notes for the component implementor:
     * 1) The component writer may perform blocking activities
     * within releaseServices, such as waiting for remote computations
     * to shutdown.
     * 2) It is good practice during releaseServices for the component
     * writer to remove or unregister all the ports it defined.
     */
    void
    releaseServices (
      /* in */const ::gov::cca::Services& services
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    /**
     *  Get a communicator of the port provider (in FORTRAN form).
     * This communicator will be the same instance as the comm of the
     * port provider, with all the message collision potential that implies.
     * Instances which have a comm covering only a subset of themselves
     * will return FORTRAN MPI_COMM_NULL on their "un-covered" processes.
     * 
     * @param tagCount: The number of tags the borrower wishes to use
     * all to itself.
     * @param tagList: Array to be filled with tags available. The
     * array given as input is at least tagCount long and
     * indexes from 0.
     * @param key: key to be returned when the tags and comm are done with.
     * @return The comm being borrowed, in FORTRAN form. C callers use comm_f2c
     * method defined by their mpi implementation, usually MPI_Comm_f2c,
     * to convert result to MPI_Comm.
     * @throw CCAException if the service cannot be implemented because MPI is
     * not present.
     */
    int64_t
    borrowComm (
      /* in */int32_t tagsRequested,
      /* inout array<int> */::sidl::array<int32_t>& tagList,
      /* inout */int32_t& key
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    /**
     *  Return a previously borrowed communicator and tag list.
     * @param tagCount: The length of tagList.
     * @param tagList: The tags being returned, at least tagCount long.
     * @param key: The key obtained with borrowComm. It is
     * an error to attempt to return tags that you didn't receive.
     * @throw CCAException if an error is detected.
     */
    void
    returnComm (
      /* in */int64_t comm,
      /* in */int32_t tagsRequested,
      /* inout array<int> */::sidl::array<int32_t>& tagList,
      /* in */int32_t key
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    /**
     *  Get an mpi communicator with the same scope as the component instance.
     * Won't be mpi_comm_null. The communicator returned will be
     * private to the recipient, which implies an mpicommdup.
     * @return The comm produced, in FORTRAN form. C callers use comm_f2c
     * method defined by their mpi implementation, usually MPI_Comm_f2c,
     * to convert result to MPI_Comm.
     * @throw CCAException if the service cannot be implemented because MPI is
     * not present.
     */
    int64_t
    getComm() // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;


    /**
     *  Let go the communicator. previously fetched with getComm.
     * @throw CCAException if an error is detected.
     */
    void
    releaseComm (
      /* in */int64_t comm
    )
    // throws:
    //    ::gov::cca::CCAException
    //    ::sidl::RuntimeException
    ;



    //////////////////////////////////////////////////
    // 
    // End User Defined Methods
    // (everything else in this file is specific to
    //  Babel's C++ bindings)
    // 

  public:
    typedef struct ccafe6_MPIComponent__object ior_t;
    typedef struct ccafe6_MPIComponent__external ext_t;
    typedef struct ccafe6_MPIComponent__sepv sepv_t;

    // default constructor
    MPIComponent() { }
    // static constructor
    static ::ccafe6::MPIComponent _create();


#ifdef WITH_RMI

    // RMI constructor
    static ::ccafe6::MPIComponent _create( /*in*/ const std::string& url );

    // RMI connect
    static inline ::ccafe6::MPIComponent _connect( /*in*/ const std::string& 
      url ) { 
      return _connect(url, true);
    }

    // RMI connect 2
    static ::ccafe6::MPIComponent _connect( /*in*/ const std::string& url, 
      /*in*/ const bool ar  );


#endif /*WITH_RMI*/

    // default destructor
    virtual ~MPIComponent () { }

    // copy constructor
    MPIComponent ( const MPIComponent& original );

    // assignment operator
    MPIComponent& operator= ( const MPIComponent& rhs );


    protected:
    // Internal data wrapping method
    static ior_t*  _wrapObj(void* private_data);


    public:
    // conversion from ior to C++ class
    MPIComponent ( MPIComponent::ior_t* ior );

    // Alternate constructor: does not call addRef()
    // (sets d_weak_reference=isWeak)
    // For internal use by Impls (fixes bug#275)
    MPIComponent ( MPIComponent::ior_t* ior, bool isWeak );

    inline ior_t* _get_ior() const throw() {
      return reinterpret_cast< ior_t*>(d_self);
    }

    inline void _set_ior( ior_t* ptr ) throw () { 
      d_self = reinterpret_cast< void*>(ptr);

      if( ptr != NULL ) {
        ccaffeine_ports_MPIBorrow_IORCache = &((
          *ptr).d_ccaffeine_ports_mpiborrow);
        gov_cca_Port_IORCache = &((*ptr).d_gov_cca_port);
        ccaffeine_ports_MPIService_IORCache = &((
          *ptr).d_ccaffeine_ports_mpiservice);
        gov_cca_ComponentRelease_IORCache = &((
          *ptr).d_gov_cca_componentrelease);
        gov_cca_Component_IORCache = &((*ptr).d_gov_cca_component);
      } else {
        ccaffeine_ports_MPIBorrow_IORCache = NULL;
        gov_cca_Port_IORCache = NULL;
        ccaffeine_ports_MPIService_IORCache = NULL;
        gov_cca_ComponentRelease_IORCache = NULL;
        gov_cca_Component_IORCache = NULL;
      }
    }

    virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                   const ::std::type_info &argtype );

    bool _is_nil() const throw () { return (d_self==0); }

    bool _not_nil() const throw () { return (d_self!=0); }

    bool operator !() const throw () { return (d_self==0); }

    static inline const char * type_name() throw () { return 
      "ccafe6.MPIComponent";}

    static struct ccafe6_MPIComponent__object* _cast(const void* src);

    // execute member function by name
    void _exec(const std::string& methodName,
               ::sidl::rmi::Call& inArgs,
               ::sidl::rmi::Return& outArgs);

    /**
     * Get the URL of the Implementation of this object (for RMI)
     */
    ::std::string
    _getURL() // throws:
    //    ::sidl::RuntimeException
    ;


    /**
     * Method to enable/disable method hooks invocation.
     */
    void
    _set_hooks (
      /* in */bool enable
    )
    // throws:
    //    ::sidl::RuntimeException
    ;


    /**
     * Method to enable/disable interface contract enforcement.
     */
    void
    _set_contracts (
      /* in */bool enable,
      /* in */const ::std::string& enfFilename,
      /* in */bool resetCounters
    )
    // throws:
    //    ::sidl::RuntimeException
    ;


    /**
     * Method to dump contract enforcement statistics.
     */
    void
    _dump_stats (
      /* in */const ::std::string& filename,
      /* in */const ::std::string& prefix
    )
    // throws:
    //    ::sidl::RuntimeException
    ;

    // return true iff object is remote
    bool _isRemote() const { 
      ior_t* self = const_cast<ior_t*>(_get_ior() );
      struct sidl_BaseInterface__object *throwaway_exception;
      return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
    }

    // return true iff object is local
    bool _isLocal() const {
      return !_isRemote();
    }

  protected:
    // Pointer to external (DLL loadable) symbols (shared among instances)
    static const ext_t * s_ext;

  public:
    static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

  }; // end class MPIComponent
} // end namespace ccafe6

extern "C" {


#pragma weak ccafe6_MPIComponent__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct ccafe6_MPIComponent__object*
  ccafe6_MPIComponent__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::ccafe6::MPIComponent > {
    typedef array< ::ccafe6::MPIComponent > cxx_array_t;
    typedef ::ccafe6::MPIComponent cxx_item_t;
    typedef struct ccafe6_MPIComponent__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct ccafe6_MPIComponent__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::ccafe6::MPIComponent > > iterator;
    typedef const_array_iter< array_traits< ::ccafe6::MPIComponent > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::ccafe6::MPIComponent >: public interface_array< array_traits< 
    ::ccafe6::MPIComponent > > {
  public:
    typedef interface_array< array_traits< ::ccafe6::MPIComponent > > Base;
    typedef array_traits< ::ccafe6::MPIComponent >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::ccafe6::MPIComponent >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::ccafe6::MPIComponent >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::ccafe6::MPIComponent >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::ccafe6::MPIComponent >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct ccafe6_MPIComponent__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::ccafe6::MPIComponent >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::ccafe6::MPIComponent >&
    operator =( const array< ::ccafe6::MPIComponent >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_gov_cca_Services_hxx
#include "gov_cca_Services.hxx"
#endif
#endif
