#include <mpi.h>
#include <iostream>
/* Generated file. Includes block */
/*---------------------------------------*/
#include <neocca.hh>
#include <neoports.hh>
#include <neosupport.hh>

/* Generated custom driver block */
/*---------------------------------------*/
#include "mpiTest_scr_NeoMain.hh"

mpiTest_scr_NeoMain::mpiTest_scr_NeoMain() {}

mpiTest_scr_NeoMain::~mpiTest_scr_NeoMain() {}

void
mpiTest_scr_NeoMain::driverBody( neo::cca::AbstractFramework *af )
throw(neo::cca::Exception)
{
	neo::cca::TypeMap_shared dummy;
	dummy = af->createTypeMap();

	neo::cca::ports::BuilderService *bs = 0;
	mpiTest_scr_NeoMain_PrivateRepository pr;

	neo::cca::Services *services;
	// set the script up as a component in the frame it receives.
	services = af->getServices("mpiTest_scr_NeoMain", "mpiTest_scr_NeoMain", dummy);
	// and find its id tag in the frame.
	neo::cca::ComponentID_shared myself = services->getComponentID();

	// tell the framework about the components that come with the driver.
	// the components from mpiTest_scr_NeoMain_PrivateRepository will now be available from
	// the BuilderService port.
	services->addProvidesPort(&pr, "mpiTest_scr_NeoMain_Factory", "neo::cca::ports::ComponentFactory");

	services->registerUsesPort("bs", "neo::cca::ports::BuilderService");


	neo::cca::Port *p = 0;
	p = services->getPort("bs");
	bs = dynamic_cast< neo::cca::ports::BuilderService *>(p);
	if (bs == 0) { throw neo::cca::Exception(neo::cca::BadPortType,
			"Service port bs is not of expected type neo::cca::ports::BuilderService");
	}
	p = 0;

	std::cerr << "####### Creating stamper s1 #########" << std::endl;

	neo::cca::ComponentID_shared s1 =
		bs->createInstance("s1", "eg::neo::SimpleStamper", dummy);
	std::cerr << "####### Creating stamper s2 #########" << std::endl;

	neo::cca::ComponentID_shared s2 =
		bs->createInstance("s2", "eg::neo::SimpleStamper", dummy);
	std::cerr << "####### Connecting stampers #########" << std::endl;

	neo::cca::ConnectionID_shared
	s1_out_port_s2_in_port =
		bs->connect(s1, "out_port", s2, "in_port");
	std::cerr << "####### Running stamper s1 #########" << std::endl;

	neo::support::helpers::invokeGo( "s1", "go", s1 , services, bs);
	std::cerr << "####### Shutting down #########" << std::endl;
	// Section to clean up connections the user didn't. reverse order.
	bs->disconnect(s1_out_port_s2_in_port, 0);

	// Section to clean up components the user didn't. reverse order.
	bs->destroyInstance(s2, 0.0);
	bs->destroyInstance(s1, 0.0);

	bs = 0;
	services->releasePort("bs");
	services->unregisterUsesPort("bs");
	services->removeProvidesPort("mpiTest_scr_NeoMain_Factory");
	// remove ourselves from the frame.
	af->releaseServices(services);
}


/* Generated extern block */
/*---------------------------------------*/
extern "C" {
	/* We expect the following functions, or equivalent with alternate names,
	 * to exist. Given these component-specific constructor wrappers,
	 * we can do the rest with generic framework facilities and do
	 * not need to include component or application specific headers.
	 *
	 * The names generated here depend on the input ccaffeine script,
	 * and may need to be adjusted to match c++ reality.
	 */
	neo::cca::Component *create_eg_neo_SimpleStamper();
	neo::cca::Component *create_neo_test_Parameter();
}

/* Generated custom factory implementation block */
/*---------------------------------------*/

void mpiTest_scr_NeoMain_PrivateRepository::addDescription(std::string name, std::string alias)
{
	neo::cca::ports::ComponentClassDescription_shared ncpccds =
		neo::support::ComponentClassDescription::create(name, alias);
	descriptions.push_back(ncpccds);
}

mpiTest_scr_NeoMain_PrivateRepository::mpiTest_scr_NeoMain_PrivateRepository() {
	addDescription("eg::neo::SimpleStamper", "eg::neo::SimpleStamper");
	addDescription("neo::test::Parameter", "neo::test::Parameter");
}

std::vector< neo::cca::ports::ComponentClassDescription_shared > mpiTest_scr_NeoMain_PrivateRepository::getAvailableComponentClasses()
{
	return descriptions;
}

std::vector< std::string> mpiTest_scr_NeoMain_PrivateRepository::getComponentClassAliases()
{
	std::vector< std::string> result;
	for (size_t i=0, n= descriptions.size(); i < n; i++)
	{
		result.push_back( descriptions[i]->getDeploymentClassAlias() );
	}
	return result;
}

neo::cca::Component * mpiTest_scr_NeoMain_PrivateRepository::createComponentInstance(const std::string & classAlias)
{
	neo::cca::TypeMap_shared tm;
	return createComponentInstance(classAlias, tm);
}

neo::cca::Component * mpiTest_scr_NeoMain_PrivateRepository::createComponentInstance(const std::string & classAlias, neo::cca::TypeMap_shared & properties)
{
	// note for users. if your components need something other than
	// the usual C wrapper (like they want to have properties passed)
	// then you will modify the code in this function.
	if (classAlias == "eg::neo::SimpleStamper") {
		// from /usr/share/eg-neo-0.9.0/components/eg_neo_SimpleStamper-0.9.0-dynamic.depl.cca .
		return create_eg_neo_SimpleStamper();
	}
	if (classAlias == "neo::test::Parameter") {
		// from /usr/share/neotest-parameter-0.1.0/components/neo_test_Parameter-0.1.0-dynamic.depl.cca .
		return create_neo_test_Parameter();
	}
	return 0; //throw?
}

void mpiTest_scr_NeoMain_PrivateRepository::destroyComponentInstance(const std::string & componentClassAlias, neo::cca::Component * component)
{
	// note for users: you may need to write a c wrapper
	// for your destructor as well if you have used
	// advanced c++ techniques for memory management.
	if ( componentClassAlias == "eg::neo::SimpleStamper"  ) {
		delete component;
	}
	if ( componentClassAlias == "neo::test::Parameter"  ) {
		delete component;
	}
}
